/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c2800\d8581_28.h> */
/****************************************************************/
/****************************************************************/
/* DAC8581 driver version 1.0 for the TMS320x280x DSPs          */
/* Copyright  2002-2006 Texas Instruments Incorporated         */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/* $Revision: 1 $                      $JustDate:  2/01/07 $    */
/* $Author: A0797073 $                                          */
/****************************************************************/
#ifndef __T8581_FN_H
#define __T8581_FN_H


#define __DCP_SP_NEW
#include "tidc_api.h"




/****************************************************************/
/** \struct TDAC8581
 *  Definition of the data converter object. This is the main
 *  object to work with.                                        */
/****************************************************************/
typedef struct
{
/** \var f
 *  Structure for the API function pointers.
 *  They are declared in tidc_api.h and defined in tidc_api.c.  */
/** \var void (*fCb*) (void*)
 *  Address of callback function passed in a dc_(read|write)block.
 *  Used to signal a end of block.                              */
/** \var void (*fCb_pend*) (void*)
 *  Address of callback function passed in a dc_(read|write)block.
 *  Used to signal a end of block. Only used if the prev block is
 *  still running and the submitted must be appended            */
/** \var iSpiPort
 *  Used SPI module                                             */
/** \var SpiRegs
 *  Base address of the register for the selected SPI module    */
/** \var uiSpiBaudrate
 *  Clock divider for SPI clock                                 */
/** \var *puiBuf
 *  Base address of data word buffer                            */
/** \var *puiBuf_pend
 *  Same as above, but for pending transfer.                    */
/** \var iNumSamp
 *  Number of data word in buffer                               */
/** \var iNumSamp_pend
 *  Same as above, but for pending transfer.                    */
/** \var iNumRxWords
 *  Holds the number of words to receive on rx line before the
 *  callback function must be called (end of transfer)          */
/** \var iNumRxWords_pend
 *  Same as above, but for pending transfer.                    */
/** \var iSetLspClk
 *  Determines whether the SPI module clock divider is
 *  reprogrammed by the DCP software or by the user program     */
/** \var iLspClkValue
 *  New clock divider value for SPI module (not the bit clock)
 *  DCP software or by the user program                         */
/** \var iDriverStatus
 *  Internal variable to track current status of the program.
 *  The variable can have the following value:
 *   - DAC8581_STAT_NOTINIT: resources not initialized (startup)
 *   - DAC8581_STAT_READY  : init'ed, but currently no transfer
 *   - DAC8581_STAT_RUN    : init'ed, transfer on progress
 *   - DAC8581_STAT_BUSY   : transfer on progress & pending*/
/****************************************************************/
    TTIDC3           f;             /* common functions         */
    void(*fCb)       (void*);       /* callback function        */
    void(*fCb_pend)  (void*);       /* pending callback func    */
    int              iSpiPort;      /* SPI port                 */
    volatile struct  SPI_REGS* SpiRegs; /* SPI Base Address     */
    unsigned int     uiSpiBaudrate; /* divider for SPI bit clk  */
    unsigned int     *puiBuf;       /* Data buffer ptr          */
    unsigned int     *puiBuf_pend;  /* Data buffer ptr (pending)*/
    int              iNumSamp;      /* # of Samples             */
    int              iNumSamp_pend; /* # of Samples (pending)   */
    int              iNumRxWords;   /* # of Samples to receive  */
    int              iNumRxWords_pend;/* # of Samples to receive*/
    int              iSetLspClk;    /* SPI module clk chg switch*/
    int              iLspClkValue;  /* SPI module clk divider   */
    volatile int     iDriverStatus; /* status of driver         */
} TDAC8581;


/****************************************************************/
/* define external DC object pointer(s)                         */
/****************************************************************/
extern TDAC8581 Dac8581_1;



/****************************************************************/
/* function definitions                                         */
/****************************************************************/
DCPAPI TTIDCSTATUS DAC8581_configure(void *pDC);
DCPAPI TTIDCSTATUS DAC8581_control(void *pDC, int iCmd, void *pValue);
DCPAPI TTIDCSTATUS DAC8581_readsample(void *pDC, long *lData);
DCPAPI TTIDCSTATUS DAC8581_writesample(void *pDC, long lData);
DCPAPI TTIDCSTATUS DAC8581_readblock(void *pDC,
                                     void *pData,
                                     unsigned long ulCount,
                                     void (*callback) (void *));
DCPAPI TTIDCSTATUS DAC8581_writeblock(void *pDC,
                                      void *pData,
                                      unsigned long ulCount,
                                      void (*callback) (void *));
DCPAPI TTIDCSTATUS DAC8581_close(void *pDC);




#endif /*__T8581_FN_H                                           */

/****************************************************************/
/* END OF t8581_fn.h                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
