/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c2800\d8581_28.c> */
/****************************************************************/
/****************************************************************/
/* DAC8581 driver version 1.0 for the TMS320x280x DSPs          */
/* Copyright  2002-2006 Texas Instruments Incorporated         */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/** \file
 * NOTE: To compile this software you need to download the document
 *       "C280x, C2801x C/C++ Header Files and Peripheral Examples"
 *       (Lit#: SPRC191) from www.ti.com and to install it in
 *       the installer's default directory.
 *
 * NOTE: The global interrupt enable bit must be set prior to a
 *       dc_configure() call.
 *
 * NOTE: The maximum SPI bit clock (running in master mode) is
 *       25MHz. The maximum update rate is 761ns (1.314MHz).
 *
 * NOTE: The buffer size for a single buffer should not be >=32 */
/*--------------------------------------------------------------*/
/* $Revision: 1 $                      $JustDate:  2/01/07 $    */
/* $Author: A0797073 $                                          */
/****************************************************************/


#undef _INLINE


#include "dc_conf.h"
#include "t8581_fn.h"
#include "DSP280x_Device.h"
/*****************************************************************/
/* static function prototypes                                    */
/*****************************************************************/
static TTIDCSTATUS InitSpi(TDAC8581* pDac);
static void DCP_DAC8581_Rx_Isr(void);
static void DCP_DAC8581_Tx_Isr(void);


/*****************************************************************/
/* define and initialize data converter objects                  */
/*****************************************************************/
#define DAC8581_STAT_NOTINIT   (-1)
#define DAC8581_STAT_READY     ( 0)
#define DAC8581_STAT_RUN       ( 1)
#define DAC8581_STAT_BUSY      ( 2)


TDAC8581* pgDac;


TDAC8581 Dac8581_1 = {
    &DAC8581_configure,
    &DAC8581_control,
    &DAC8581_readsample,
    &DAC8581_writesample,
    &DAC8581_readblock,
    &DAC8581_writeblock,
    &DAC8581_close,
    0, 0, 3,            /* reserved                              */
    0,                  /* callback pointer                      */
    0,                  /* pending cb pointer                    */
    DAC1_SPIPORT,                       /* used SPI port            */
    (struct SPI_REGS*)DAC1_SPIBASEADDR, /* SPI address              */
    DAC1_SPIBAUDRATE,                   /* value for SPI speed      */
    0,                                  /* Data Buffer Ptr          */
    0,                                  /* Number of Samples        */
    0,                                  /* Data Buffer Ptr (pend)   */
    0,                                  /* Number of Samples (pend) */
    DAC1_SETLSPCLK,                     /* LSP clk set by DCP?      */
    DAC1_LSPCLKVAL,                     /* value for LSPCLK         */
    DAC8581_STAT_NOTINIT/* status flag              */
};



/*****************************************************************/
/* DAC8581_configure()                                           */
/**Operation:
 *    - Initializes the SPI
 *    - Optionally changes the LSP clock divider
 *
 * Parameters:
 *    - Data converter object
 *
 * Return value:
 *    - all from DAC8581_control()
 *    - TIDC_ERR_NOCHIPRES                                       */
/*****************************************************************/
TTIDCSTATUS DAC8581_configure(void* pDC)
{
   TDAC8581* pDac = (TDAC8581*)pDC;
   
   /* be sure there was not previous configuration               */
   if (pDac->iDriverStatus != DAC8581_STAT_NOTINIT) {
      return TIDC_ERR_NOCHIPRES;
   }
   if (InitSpi(pDac) != TIDC_NO_ERR) {
      (void)DAC8581_close(pDC);
      return TIDC_ERR_NOCHIPRES;
   }


   /* let the other functions know the resources are open/init   */
   pDac->iDriverStatus = DAC8581_STAT_READY;
   
   return TIDC_NO_ERR;
}


/*****************************************************************/
/* DAC8581_control()                                             */
/**This function is not implemented                              */
/*****************************************************************/
TTIDCSTATUS DAC8581_control(void *pDC, int iCmd, void *pValue)
{
   return TIDC_ERR_FXNNULL;
}


/*****************************************************************/
/* DAC8581_readsample()                                          */
/**This function is not implemented                              */
/*****************************************************************/


TTIDCSTATUS DAC8581_readsample(void *pDC, long* lData)
{
   return TIDC_ERR_FXNNULL;
}


/*****************************************************************/
/* DAC8581_readblock()                                           */
/**This function is not implemented                              */
/*****************************************************************/
TTIDCSTATUS DAC8581_readblock(void *pDC,
                              void *pData,
                              unsigned long ulCount,
                              void (*callback) (void *))
{
   return TIDC_ERR_NOCHIPRES;
}


/*****************************************************************/
/* DAC8581_writesample()                                         */
/**Operation:
 *    - Writes a single data word to the converter
 *
 * Parameters:
 *    - Data converter object
 *    - Data word to be written to the converter
 *
 * Return value:
 *    - TIDC_NO_ERR
 *    - TIDC_ERR_NODEVICE
 *    - TIDC_ERR_XFERPROG                                        */
/*****************************************************************/
TTIDCSTATUS DAC8581_writesample(void *pDC, long lData)
{
   TDAC8581* pDac = (TDAC8581*)pDC;
   volatile int iData;
   
   if (pDac->iDriverStatus == DAC8581_STAT_NOTINIT) {
      return TIDC_ERR_NODEVICE;
   }
   if (pDac->iDriverStatus != DAC8581_STAT_READY) {
      return TIDC_ERR_XFERPROG;
   }
   /* wait until we have at least one space free in FIFO         */
   while((*pDac->SpiRegs).SPIFFTX.bit.TXFFST != 0);
   /* write word to FIFO                                         */
   (*pDac->SpiRegs).SPITXBUF = (unsigned int)lData;
   /* wait until receiver has complete word (marks e/o transfer) */
   while((*pDac->SpiRegs).SPIFFRX.bit.RXFFST != 1);
   /* dummy read                                                 */
   iData = (*pDac->SpiRegs).SPIRXBUF;


   return TIDC_NO_ERR;
}


/*****************************************************************/
/* DAC8581_writeblock()                                          */
/**Operation:
 *    - Writes a block of data words to the converter
 *
 * Parameters:
 *    - Data converter object
 *    - Pointer to data words field
 *    - Number of words
 *    - Address of callback function
 *
 * Return value:
 *    - TIDC_NO_ERR
 *    - TIDC_ERR_NODEVICE
 *    - TIDC_ERR_XFERPROG
 *    - TIDC_ERR_BADARGS                                         */
/*****************************************************************/
TTIDCSTATUS DAC8581_writeblock(void *pDC,
                               void *pData,
                               unsigned long ulCount,
                               void (*callback) (void *))
{
   TDAC8581* pDac = (TDAC8581*)pDC;
   int i;
   
   /* parameter & availability check                             */
   if (pDac->iDriverStatus == DAC8581_STAT_NOTINIT)
      return TIDC_ERR_NODEVICE;
   if (pDac->iDriverStatus == DAC8581_STAT_BUSY)
      return TIDC_ERR_XFERPROG;
   if ((ulCount < 0x00000010u) ||
       (ulCount > 0x00007FFFu) ||
       (ulCount & 0x7))
      return TIDC_ERR_BADARGS;
   
   pgDac = pDac;
   
   /* save parameter of transfer job dependent on driver status  */
   if (pDac->iDriverStatus == DAC8581_STAT_READY) {
      pDac->iNumRxWords   = ulCount;
      pDac->iNumSamp      = ulCount-8;
      pDac->puiBuf        = (unsigned int*)pData;
      pDac->fCb           = callback;
      pDac->iDriverStatus = DAC8581_STAT_RUN;
   } else { /* DAC8581_STAT_RUN                                  */
      pDac->iNumRxWords_pend = ulCount;
      pDac->iNumSamp_pend    = ulCount;
      pDac->puiBuf_pend      = (unsigned int*)pData;
      pDac->fCb_pend         = callback;
      pDac->iDriverStatus    = DAC8581_STAT_BUSY;
      return TIDC_NO_ERR;
   }
   while((*pDac->SpiRegs).SPIFFTX.bit.TXFFST > 0);
   /* write 16 sample to the FIFO                                */
   for (i=0; i<8; i++)
      (*pDac->SpiRegs).SPITXBUF = *pDac->puiBuf++;


   /* clear FIFO interrupt                                       */
   (*pgDac->SpiRegs).SPIFFTX.bit.TXFFINTCLR = 1;
   /* enable SPI interrupt in PIE                                */
   PieCtrlRegs.PIEIER6.bit.INTx2 = 1;
   return TIDC_NO_ERR;
}


/*****************************************************************/
/* DAC8581_close()                                               */
/**Operation:
 *    - Closes all DSP resources used by this software
 *
 * Parameters:
 *    - Data converter object
 *
 * Return value:
 *    - TIDC_NO_ERR                                              */
/*****************************************************************/
TTIDCSTATUS DAC8581_close(void *pDC)
{
   TDAC8581* pDac = (TDAC8581*)pDC;
   
   /* parameter & availability check                             */
   if (pDac->iDriverStatus == DAC8581_STAT_NOTINIT)
      return TIDC_ERR_NODEVICE;
   
   /* Reset FIFOs                                                */
   (*pDac->SpiRegs).SPIFFTX.bit.TXFIFO = 0;
   (*pDac->SpiRegs).SPIFFRX.bit.RXFIFORESET = 0;
   /* disable SPI                                                */
   (*pDac->SpiRegs).SPICCR.bit.SPISWRESET = 0;


   pDac->iDriverStatus = DAC8581_STAT_NOTINIT;
   
   return TIDC_NO_ERR;
}


/*****************************************************************/
/* DCP_DAC8581_Tx_Isr()                                          */
/**Operation:
 *    - Interrupt service routine served when the Tx FIFO reaches
 *      the trigger level (new data samples will be copied to FIFO
 *      if available.
 *
 * Parameters:
 *    - None
 *
 * Return value:
 *    - None                                                     */
/*****************************************************************/
interrupt void DCP_DAC8581_Tx_Isr(void)
{
   if (pgDac->iNumSamp == 0) {
      /* if a job is pending, reload variables                   */
      if (pgDac->iDriverStatus == DAC8581_STAT_BUSY) {
         pgDac->puiBuf        = pgDac->puiBuf_pend;
         pgDac->iNumSamp      = pgDac->iNumSamp_pend;
         pgDac->iDriverStatus = DAC8581_STAT_RUN;
      }
      else {
         pgDac->iDriverStatus = DAC8581_STAT_READY;
         PieCtrlRegs.PIEIER6.bit.INTx2 = 0;
	     /* clear FIFO interrupt flag                                  */
	     (*pgDac->SpiRegs).SPIFFTX.bit.TXFFINTCLR = 1;
	     /* acknowledge PIE group                                      */
	     PieCtrlRegs.PIEACK.all |= PIEACK_GROUP6;
        return;
      }
   }
   pgDac->iNumSamp = pgDac->iNumSamp - 8;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   (*pgDac->SpiRegs).SPITXBUF = *pgDac->puiBuf++;
   /* clear FIFO interrupt flag                                  */
   (*pgDac->SpiRegs).SPIFFTX.bit.TXFFINTCLR = 1;
   /* acknowledge PIE group                                      */
   PieCtrlRegs.PIEACK.all |= PIEACK_GROUP6;
}


/*****************************************************************/
/* DCP_DAC8581_Rx_Isr()                                          */
/**Operation:
 *    - Interrupt service routine served when the Rx FIFO reaches
 *      the trigger level
 *    - this ISR is needed to recognize the end of transfer
 *      (last word has been shifted out completely)
 *
 * Parameters:
 *    - None
 *
 * Return value:
 *    - None                                                     */
/*****************************************************************/
interrupt void DCP_DAC8581_Rx_Isr(void)
{
	volatile int iData;


	pgDac->iNumRxWords = pgDac->iNumRxWords - 8;
	if (pgDac->iNumRxWords == 0) {
    	if (pgDac->fCb != (void*)0x00000000) {
    	     pgDac->fCb(pgDac);
		}
	    pgDac->fCb        = pgDac->fCb_pend;
		pgDac->iNumRxWords = pgDac->iNumRxWords_pend;
   }
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   iData = (*pgDac->SpiRegs).SPIRXBUF;
   /* clear FIFO interrupt flag                                  */
   (*pgDac->SpiRegs).SPIFFRX.bit.RXFFINTCLR = 1;
   /* acknowledge PIE group                                      */
   PieCtrlRegs.PIEACK.all |= PIEACK_GROUP6;
}


/*****************************************************************/
/* Static functions                                              */
/*****************************************************************/
/*****************************************************************/
/* InitSpi()                                                     */
/**Operation:
 *    - Opens and inits the selected SPI port
 *
 * Parameters:
 *    - Data converter object
 *
 * Return value:
 *    - TIDC_NO_ERR
 *    - TIDC_ERR_NOCHIPRES                                       */
/*****************************************************************/
static TTIDCSTATUS InitSpi(TDAC8581* pDac)
{
   EALLOW;
   /* set the LSPCLK field in LOSPCP, if requested by the user   */
   if (pDac->iSetLspClk)
      SysCtrlRegs.LOSPCP.bit.LSPCLK = pDac->iLspClkValue;
   
   /* set pins to be used as SPI interface                       */
   /* Pin assignments                                            */
   /* SPICLK  = 18  SPISTE  = 19                                 */
   /* SPIMOSI = 16  SPIMISO = 17                                 */
   /* enable pull-up resistor                                    */
   GpioCtrlRegs.GPAPUD.bit.GPIO16 = 0;
   GpioCtrlRegs.GPAPUD.bit.GPIO17 = 0;
   GpioCtrlRegs.GPAPUD.bit.GPIO18 = 0;
   GpioCtrlRegs.GPAPUD.bit.GPIO19 = 0;
   /* no qualification                                           */
   GpioCtrlRegs.GPAQSEL2.bit.GPIO16 = 3;
   GpioCtrlRegs.GPAQSEL2.bit.GPIO17 = 3;
   GpioCtrlRegs.GPAQSEL2.bit.GPIO18 = 3;
   GpioCtrlRegs.GPAQSEL2.bit.GPIO19 = 3;
   /* pins to be used as SPI                                     */
   GpioCtrlRegs.GPAMUX2.bit.GPIO16 = 1;
   GpioCtrlRegs.GPAMUX2.bit.GPIO17 = 1;
   GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 1;
   GpioCtrlRegs.GPAMUX2.bit.GPIO19 = 1;
   
   PieVectTable.SPIRXINTA = &DCP_DAC8581_Rx_Isr;
   PieVectTable.SPITXINTA = &DCP_DAC8581_Tx_Isr;
   /* enable SPI Rx interrupt in PIE                             */
   PieCtrlRegs.PIEIER6.bit.INTx1 = 1;


   /* enable FIFO, clr flag                                      */
   (*pDac->SpiRegs).SPIFFTX.all = 0xC068;
   /* receive FIFO not used                                      */
   (*pDac->SpiRegs).SPIFFRX.all = 0x4068;
   /* delay between character transfers: 3                       */
   (*pDac->SpiRegs).SPIFFCT.all = 0x0003;


   /* data output rising edge, 16bit character                   */
   (*pDac->SpiRegs).SPICCR.all = 0x000F;
   /* clock delay, master, talk, interrupt enabled               */
   (*pDac->SpiRegs).SPICTL.all = 0x000F;
   /* set speed of SPI                                           */
   (*pDac->SpiRegs).SPIBRR = pDac->uiSpiBaudrate;
   /* run free                                                   */
   (*pDac->SpiRegs).SPIPRI.all = 0x0010;
   
   /* enable SPI                                                 */
   (*pDac->SpiRegs).SPICCR.bit.SPISWRESET = 1;
   /* enable TX FIFO operation                                   */
   (*pDac->SpiRegs).SPIFFTX.bit.TXFIFO = 1;
   /* enable RX FIFO operation                                   */
   (*pDac->SpiRegs).SPIFFRX.bit.RXFIFORESET = 1;


   EDIS;
   /* enable INT6 of IER to get the SPI interrupt                */
   IER |= M_INT6;
   return TIDC_NO_ERR;
}

/****************************************************************/
/* END OF t8581_ob.c                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
